Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Contracts
Imports System.ServiceModel
Imports System.Threading
Imports System.ServiceModel.Description
Imports System.Workflow.Runtime
Imports System.Workflow.Runtime.Hosting
Imports System.ServiceModel.Channels

Namespace HostApplication
	''' <summary>
	''' Interaction logic for Window1.xaml
	''' </summary>
	Partial Public Class Window1
		Inherits Page

		Public Sub New()
			InitializeComponent()
		End Sub


		Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			'IWorkflowInterface proxy = GetProxy();
			'SetupContextManagerForMultipleInstances(ref proxy);

			Dim a As App = CType(Application.Current, App)

			Dim proxy As IWorkflowInterface = New ChannelFactory(Of IWorkflowInterface)(a.LocalBinding, a.WFAddress).CreateChannel()

			proxy.SubmitOrder(New Order With {.CustomerName = "Matt", .OrderID = 0, .OrderTotal = 250.00})

			GetWorkflowInstance(proxy)
		End Sub

		Private Sub SetupContextManagerForMultipleInstances(ByRef proxy As IWorkflowInterface)
			Dim mgr As IContextManager = (CType(proxy, IClientChannel)).GetProperty(Of IContextManager)()
			mgr.Enabled = False
		End Sub

		Private Sub GetWorkflowInstance(ByVal proxy As IWorkflowInterface)
			Dim mgr As IContextManager = (CType(proxy, IClientChannel)).GetProperty(Of IContextManager)()

			Dim wfID As String = mgr.GetContext()("instanceId")
			wfIdText.Text = wfID
		End Sub

		Private Function GetProxy() As IWorkflowInterface
			Dim a As App = CType(Application.Current, App)

			Dim proxy As IWorkflowInterface = New ChannelFactory(Of IWorkflowInterface)(a.LocalBinding, a.WFAddress).CreateChannel()
			'SetupContextManagerForMultipleInstances(ref proxy);
			Return proxy
		End Function



		Private Sub Button_Click_1(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim proxy As IWorkflowInterface = GetProxy()
			'SetupContextManagerForMultipleInstances(ref proxy);

			SetWorkflowIDOnProxy(proxy)

			proxy.UpdateOrder(New Order With {.CustomerName = "Matt", .OrderID = 2, .OrderTotal = 250.00, .OrderStatus="Updated"})
		End Sub

		Private Sub SetWorkflowIDOnProxy(ByVal proxy As IWorkflowInterface)
			Dim mgr As IContextManager = (CType(proxy, IClientChannel)).GetProperty(Of IContextManager)()
            Dim context As New Dictionary(Of String, String)
            context.Add("instanceId", wfIdText.Text)
            mgr.SetContext(context)
		End Sub

		Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim host As HostService = TryCast((CType(Application.Current, App)).appHost.SingletonInstance, HostService)
			If host IsNot Nothing Then
				Me.DataContext = host
			End If
		End Sub
	End Class
End Namespace
