Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Workflow.ComponentModel
Imports System.Windows.Forms

Namespace WorkflowsAndActivities
	Public Class WriteLine
		Inherits Activity
		Public Shared OutputTextProperty As DependencyProperty = DependencyProperty.Register("OutputText", GetType(String), GetType(WriteLine))

		<System.ComponentModel.DescriptionAttribute("The text to be written"), System.ComponentModel.CategoryAttribute("Console"), System.ComponentModel.BrowsableAttribute(True), System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)> _
		Public Property OutputText() As String
			Get
				Return (CStr(MyBase.GetValue(WriteLine.OutputTextProperty)))
			End Get
			Set(ByVal value As String)
				MyBase.SetValue(WriteLine.OutputTextProperty, value)
			End Set
		End Property

		Public Shared ForegroundColorProperty As DependencyProperty = DependencyProperty.Register("ForegroundColor", GetType(ConsoleColor), GetType(WriteLine))

		<System.ComponentModel.DescriptionAttribute("Foreground Color for the text"), System.ComponentModel.CategoryAttribute("Console"), System.ComponentModel.BrowsableAttribute(True), System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)> _
		Public Property ForegroundColor() As ConsoleColor
			Get
				Return (CType(MyBase.GetValue(WriteLine.ForegroundColorProperty), ConsoleColor))
			End Get
			Set(ByVal value As ConsoleColor)
				MyBase.SetValue(WriteLine.ForegroundColorProperty, value)
			End Set
		End Property

		Protected Overrides Function Execute(ByVal executionContext As ActivityExecutionContext) As ActivityExecutionStatus
            Console.ForegroundColor = ForegroundColor

			'Console.WriteLine(OutputText);

			Console.ResetColor()

			MessageBox.Show(OutputText)
			Return ActivityExecutionStatus.Closed

		End Function
	End Class
End Namespace
